package prodcons01;
public class Main {
    public Main() {
    }
 
    public static void main(String[] args) {
        	Pila.encabe();
		Pila pila = new Pila();
		Productor prod = new Productor(pila);
		Consumidor cons = new Consumidor(pila);
		prod.start();
		cons.start();
    }
}

// PRODUCTOR 
class Productor extends Thread{
	private Pila pila;
	private String alfabeto = "ABCDEFGHIJ";

	public Productor( Pila letra){	
		pila = letra;
	}

	public void run(){ 
		char letra;
		for( int i = 0; i < alfabeto.length(); i++ ){// Apila letras
			letra = alfabeto.charAt(i);
                        pila.apilar( letra );
                        System.out.println(" "+letra);
                        try{ // Da una chance al hilo consumidor 
                            sleep( (int) (Math.random()*200 ) );
                        }catch( InterruptedException e ) {;} 
		}
                pila.FinPro(); // Fin de la produccin
	}
}

// Creamos una instancia de la clase Pila, y utilizamos  
// pila.apilar() para ir produciendo.

// CONSUMIDOR 
class Consumidor extends Thread{
    private Pila pila;
    public Consumidor( Pila t){pila = t;}

    public void run(){ 
        char letra;
        try { sleep (200 );
        } catch( InterruptedException e ){;} 
        while(pila.HayStock() || pila.HayProd()){
            letra = pila.sacar();
            System.out.println("       "+letra);
            try{ //Da una chance al hilo productor
                sleep( (int) (Math.random() *400 )); 
            } catch( InterruptedException e ){;}
        }  // while
    }  // run
} // class consumidor

// MONITOR 
class Pila{ 
    private char buffer[] = new char[10];
    private int siguiente = 0;
    // Sigen flags para saber el estado del buffer 
    private boolean estaLlena = false;
    private boolean estaVacia = true;
    private boolean esperanza = true; // (De produccin)
 
    public static void encabe (){
        System.out.println ("Prod. cons.");
    }
 
    public synchronized char sacar(){ // Mtodo para consumir
        while(estaVacia){ // esperando para consumir  
            try{ 
                wait() ;
            }catch(InterruptedException e){;}
	}
	// podemos consumir, entonces: 
	siguiente--; // decrementamos, vamos consumir 
	if(siguiente == 0) // Fu la ltima, ya no quedan
            estaVacia = true; // mas letras 
            estaLlena = false; 	// acabamos de consumir) 
            notify() ;
            return(buffer[siguiente]); // consumimos
    } 

    public synchronized void apilar( char letra) { // producir
        while( estaLlena){ // Ciclo de espera por sitio donde  
                        // almacenar esta nueva produccin.
            try{ // Lo habr cuando sacar() cambie esta
                wait(); // bandera a false 
            }catch( InterruptedException e){;}
        }
        buffer[siguiente++] = letra;
        if( siguiente == 10 ) // Comprueba si el buffer est lleno
            estaLlena = true;
        estaVacia = false;
        notify();
    }

    public synchronized void FinPro(){esperanza=false;}

    public synchronized boolean HayProd(){return esperanza;}

    public synchronized boolean HayStock(){return !estaVacia;}
}

