import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
class BounceFrame extends JFrame{   //   Estructura con el canvas y botones
   private BallCanvas canvas;       //   Referencia a mi clase BallCanvas
   public static final int WIDTH = 450;
   public static final int HEIGHT = 350;  

   /**
    * Construye la estructura con el area canvas para mostrar la bola
    * y los botones Start y Close.
    * La clase Canvas provee un area rectangular con capacidad para que   
    * la aplicacion pueda dibujar graficos e imagenes 
    * y atrapar eventos del usuario
   */
   
   public BounceFrame(){    //  Constructor
      setSize(WIDTH, HEIGHT);
      setTitle("BounceThread");
      
      Container contentPane = getContentPane(); // Defino contenedor
      canvas = new BallCanvas();            //    instancio BallCanvas 
      // Incorporo canvas al contentPane, region CENTER
      contentPane.add(canvas, BorderLayout.CENTER);
      JPanel buttonPanel = new JPanel();    //    panel para botones
      // Incorporo boton start al buttonPanel (usando metodo add propio)
      addButton(buttonPanel, "Start",new ActionListener(){  
         public void actionPerformed(ActionEvent evt){addBall();}});
      
      // Incorporo boton close al buttonPanel
      addButton(buttonPanel, "Close",new ActionListener(){ 
         public void actionPerformed(ActionEvent evt){System.exit(0);}});
      // Incorporo buttonPanel al contentPane, region SOUTH      
      contentPane.add(buttonPanel, BorderLayout.SOUTH);
   }

   //   Mi metodo addButton propio 
   public void addButton(Container c, String title, ActionListener listener){
      JButton button = new JButton(title);
      c.add(button);
      button.addActionListener(listener);
   }

   //   incorporo mi bola al canvas y arranco hilo de rebotes
   public void addBall(){
      Ball b = new Ball(canvas);
      canvas.add(b);
      BallThread thread = new BallThread(b);
      thread.start();
   }
}   //  class BounceFrame

